%define version 0.4.14
%define release 1mdk

Summary: Cluster administation tools  
Name: piranha
Version: %{version}
Release: %{release}
Copyright: GPL 
Group: Networking/Other 
Source0: piranha-%{PACKAGE_VERSION}.tar.bz2
Source1: %{name}.xpm
Buildroot: %{_tmppath}/piranha-buildroot
Prereq: /sbin/chkconfig 
Prefix: %{_prefix}

%package gui
Requires: piranha 
Summary: The cute little graphical configuration tool for lvs
Group: System/Configuration/Networking
Requires: apache php

%package docs
Summary: Documentation for a Linux-Mandrake clustering environment
Group: Networking/Other

%description 
Various tools to administer and configure the Linux Virtual Server as well as
heartbeating and failover components.  The LVS is a dynamically adjusted
kernel routing mechanism that provides load balancing for web servers and ftp
servers.  

%description docs
This package contains documentation files found on the Internet as well as
some written by Red Hat.  These files include the HTML contents of
www.linuxvirtualserver.org.

%description gui
Piranha is a GUI frontend tool to administer the cluster nodes.  It calls
the lvs backend daemon to manage and edit the lvs configuration file.

%prep
%setup -n piranha -q
mv docs/HOWTO.lvs HOWTO.lvs


%build
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS" all

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make install prefix=$RPM_BILD_ROOT/%{prefix}


mkdir -p $RPM_BUILD_ROOT/home/httpd/html/piranha
cp -Rfv web/* $RPM_BUILD_ROOT/home/httpd/html/piranha
echo /home/httpd/html/piranha > HTMLFILES

mkdir -p $RPM_BUILD_ROOT/etc
touch $RPM_BUILD_ROOT/etc/piranha.passwd
chmod 600 $RPM_BUILD_ROOT/etc/piranha.passwd
chown root.root $RPM_BUILD_ROOT/etc/piranha.passwd

mkdir -p $RPM_BUILD_ROOT/usr/share/icons/mini
install -m644 %{SOURCE1} $RPM_BUILD_ROOT/usr/share/icons/mini/%{name}.xpm
mkdir -p $RPM_BUILD_ROOT/usr/lib/menu/
cat << EOF > $RPM_BUILD_ROOT/usr/lib/menu/%{name}-gui
?package(%{name}-gui): \
 command="kdesu -c /usr/sbin/piranha" \
 needs="X11" icon="none" \
 section="Configuration/Networking" \
 title="Piranha" \
 longtitle="Clustering configuration and administration tool"
EOF

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/groupadd -g 60 -r -f piranha > /dev/null 2>&1 ||:
/usr/sbin/useradd -u 60 -g 60 -d /home/httpd/html/piranha -r -s \
	/dev/null piranha > /dev/null 2>&1 ||:

touch /etc/lvs.cf
chmod 664 /etc/lvs.cf
chown piranha.nobody /etc/lvs.cf

%pre gui
if [ `grep -c html/piranha /etc/httpd/conf/access.conf` = 0 ]; then
       echo "<Directory /home/httpd/html/piranha>" >> /etc/httpd/conf/access.conf
       echo "  Options All" >> /etc/httpd/conf/access.conf
       echo "  AllowOverride All" >> /etc/httpd/conf/access.conf
       echo "</Directory>" >> /etc/httpd/conf/access.conf
fi


%preun
if [ $1 = 0 ]; then
	/sbin/chkconfig --del pulse
fi

%post 
/sbin/chkconfig --add pulse


%postun
if [ "$1" = 0 ] ; then
        userdel piranha
fi

%post gui
if [ -x /usr/bin/update-menus ];then
		/usr/bin/update-menus
fi

%postun gui
if [ -x /usr/bin/update-menus ];then
		/usr/bin/update-menus
fi

%files
%defattr(-,root,root)
%doc sample.cf AUTHORS COPYING Changelog README gui/README.gui
%config /etc/rc.d/init.d/pulse
/usr/sbin/ipvsadm
/usr/sbin/lvs
/usr/sbin/fos
/usr/sbin/nanny
/usr/sbin/pulse
/usr/sbin/send_arp
/usr/man/man5/lvs.cf.5*
/usr/man/man8/*

%files docs
%defattr(-,root,root)
%doc docs/*
%doc sample.cf AUTHORS COPYING Changelog README HOWTO.lvs

%files gui -f HTMLFILES
%defattr(-,root,root)
%doc web/* web/secure/* pics/*
%doc AUTHORS COPYING README
/usr/lib/menu/%{name}-gui
%config(noreplace) /etc/piranha.passwd
/usr/share/icons/mini/%{name}.xpm
/usr/sbin/piranha
/usr/sbin/piranha-passwd

%changelog
* Wed Apr 26 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.4.14-1mdk
- 0.4.14.

* Tue Apr 25 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 0.4.13-1mdk
- Add menu/icons entry for gui configuration.
- 0.4.13:
  Security exposure raised by ISS regarding the passwd.php3
  file fixed by replacing the external call to htpasswd with
  php3s own crypt function (see parse.php3 change_password)

* Tue Apr 18 2000 Pixel <pixel@mandrakesoft.com> 0.4.12-2mdk
- fix % pre (access.conf doesn't exist any more)

* Wed Apr 05 2000 Christopher Molnar <molnarc@mandrakesoft.com> 0.4.12-1mdk
- fixed the groups

* Mon Apr 04 2000 Christopher Molnar <molnarc@mandrakesoft.com> 0.4.12-1mdk
- Updgraded to 0.4.12-1mdk

* Tue Mar 07 2000 Mike Wangsmo <wanger@redhat.com>
- removed killapache
- changed sample httpd shutdown to use proper init scripts
- Keith fixed MORONIC spelling error in pulse.c :)
- moved the GUI README into the %doc list

* Tue Mar 07 2000 Keith Barrett <kbarrett@redhat.com>
- Improved take control heartbeat login in pulse
- Enhanced old GUI README to notify user of special conditions
- Bumped version

* Mon Mar 06 2000 Keith Barrett <kbarrett@redhat.com>
- Bumped version to reflect changes to fos, pulse, and old GUI

* Sun Mar 05 2000 Mike Wangsmo <wanger@redhat.com>
- added fos to file list
- moved apache & php requires to gui package
- reordered the install of killapache to make strip not puke

* Sat Mar  5 2000 Keith Barrett <kbarrett@redhat.com>
- Corrected signaling, heartbeat, and failover in pulse
- Bumped version to reflect a stable release
- Note: pulse USR1/2 disabled in this checkin

* Thu Mar  4 2000 Keith Barrett <kbarrett@redhat.com>
- Corrected memory errors in parser
- Updated fos
- Improved (but have not finished) pulse changes
- Bumped version to reflect parser change

* Wed Mar  2 2000 Philip Copeland <copeland@redhat.com>
- Added password services to web control
- Altered pulse to provide a signal escalator between nobody/root
  as we now have a "use a uid/gid < 100" limitation that
  apache's suexec doesn't cater for
- Added default password to web (null)
- minor spec file changes

* Thu Mar  2 2000 Keith Barrett <kbarrett@redhat.com>
- New version of pulse with enhanced signals
- New service = xxx parameter in config system
- New man pages and doc updates

* Wed Mar  1 2000 Keith Barrett <kbarrett@redhat.com>
- Checked in failover service changes. Not fully
- functional yet.

* Wed Mar  1 2000 Bill Nottingham <notting@redhat.com>
- use a uid/gid < 100

* Mon Feb 28 2000 Mike Wangsmo <wanger@redhat.com>
- fiddled with the /etc/lvs.cf stuff some more

* Fri Feb 25 2000 Mike Wangsmo <wanger@redhat.com>
- *NO* "echo's" in spec files!
- made /etc/lvs.cf a %config so it'll get backed up on upgrades
- cleaned up some useradd/groupadd errors

* Fri Feb 25 2000 Keith Barrett <kbarrett@redhat.com>
- Fixed parsing of protocol = xxx
- Bumped version (again)

* Tue Feb 22 2000 Keith Barrett <kbarrett@redhat.com>
- Fixed passthrough of routing type options
- Fixed man pages to reflect routing type options
- Changed formatting of sample.cf file and included comments
- Bumped version number

* Mon Feb 21 2000 Keith Barrett <kbarrett@redhat.com>
- Fixed segfault problem in nanny
- Minor changes reporting the phase out of the old GUI
- Bumped version number
- Changed spec file to include web in GUI RPM

* Fri Feb 18 2000 Keith Barrett <kbarrett@redhat.com>
- Bumped version to reflect Bryce's changes to install scripts
- Added persistent netmask to lvsconfig and lvs and sample.cf

* Thu Feb 17 2000  Keith Barrett <kbarrett@redhat.com>
- Bumped version
- Improved send/expect stuff

* Wed Feb 16 2000  Keith Barrett <kbarrett@redhat.com>
- Bumped version to reflect GUI changes

* Tue Feb 15 2000 Keith Barrett <kbarrett@redhat.com>
- Added send/expect parsing to lvs, lvsconfig, and nanny.
- Updated nanny man page and sample.cf file

* Tue Feb 15 2000 Mike Wangsmo <wanger@redhat.com>
- added a groupadd line so useradd wouldn't fail.

* Mon Feb 14 2000 Keith Barrett <kbarrett@redhat.com>
- added generic service parameters to nanny.c and nanny.8

* Fri Feb 11 2000 Mike Wangsmo <wanger@redhat.com>
- added uid/gid piranha to setup (233)
- cleaned up %install a bit

* Mon Feb 09 2000 Philip Copeland <copeland@redhat.com>
- Added NAT/direct routing/tunneling to the web interface
- fixed up the web documents to tell the web browsers that
  caching them would be a BAD idea
- Added some prettify stuff

* Mon Feb 07 2000 Keith Barrett <kbarrett@redhat.com>
- Changed pulse call to send_arp to /usr/sbin
- Suppress sock error on unconfigured tunl device
- Bumped version

* Sat Feb 05 2000 Mike Wangsmo <wanger@redhat.com>
- removed piranha-web package and put it into main package

* Fri Feb 04 2000 Keith Barrett <kbarrett@redhat.com>
- Added Bryce's README.beta to beta release

* Thu Feb 03 2000 Nalin Dahyabhai <nalin@redhat.com>
- check that RPM_BUILD_ROOT != / when installing
- handle case if httpd not installed during %install
- handle gzipped man pages

* Thu Feb 03 2000 Mike Wangsmo <wanger@redhat.com>
- tagged the desktop entry as %config

* Thu Jan 27 2000 Keith Barrett <kbarrett@redhat.com>
- Minor updates to doc files and man pages.
- Added headers and history to some source files
- Created nanny.h file

* Sat Sep 25 1999 Mike Wangsmo <wanger@redhat.com>
- added the HOWTO

* Fri Sep 24 1999 Mike Wangsmo <wanger@redhat.com>
- added KDE desktop entry
- added piranha icon pixmap
- fixed *tons* of lvs <-> gui glue problems

* Tue Sep 21 1999 Mike Wangsmo <wanger@redhat.com>
- added a send_arp tool to the package
- removed the /etc/lvs.cf entry (it was dumb here)
- strip all binaries too
- added nanny to package

* Tue Sep 21 1999 Mike Wangsmo <wanger@redhat.com>
- moved all bins to /usr/sbin
- added pulse init script

* Mon Sep 20 1999 Mike Wangsmo <wanger@redhat.com>
- moved piranha to its own package

* Thu Sep 9 1999 Mike Wangsmo <wanger@redhat.com>
- added the documents package

* Wed Sep 8 1999 Mike Wangsmo <wanger@redhat.com>
- added a few more files to the file list
- relocated some things.
- put in a stub config file

* Tue Sep 7 1999 Mike Wangsmo <wanger@redhat.com>
- restructured the package to come from CVS
- renamed it
- added oot's lvs daemon
- added the perl client_monitor tool from Lars Marowsky-Bree
- put stubs in for the GUI
- buffed up the Makefile

* Sun Jul 25 1999 Mike Wangsmo <wanger@redhat.com>
- initial build
